import { Plugin, PropType, ExtractPropTypes } from 'vue';
import * as CSS from "csstype";
import { EditorState } from "@codemirror/state";
import { EditorView, ViewUpdate } from "@codemirror/view";
declare const globalProps: {
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: PropType<CSS.Properties<string | 0>>;
    root: PropType<ShadowRoot | Document>;
    extensions: PropType<import("@codemirror/state").Extension | undefined>;
    selection: PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
};
type Props = ExtractPropTypes<typeof globalProps>;
declare const DEFAULT_CONFIG: Readonly<Partial<Props>>;
declare const _default: import("vue").DefineComponent<{
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: PropType<CSS.Properties<string | 0>>;
    root: PropType<ShadowRoot | Document>;
    extensions: PropType<import("@codemirror/state").Extension | undefined>;
    selection: PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
    modelValue: {
        type: StringConstructor;
        required: false;
        default: string;
    };
}, () => import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "update:modelValue": (value: string, viewUpdate: ViewUpdate) => true;
    change: (value: string, viewUpdate: ViewUpdate) => true;
    update: (viewUpdate: ViewUpdate) => true;
    focus: (viewUpdate: ViewUpdate) => true;
    blur: (viewUpdate: ViewUpdate) => true;
    ready: (payload: {
        view: EditorView;
        state: EditorState;
        container: HTMLDivElement;
    }) => true;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<ExtractPropTypes<{
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: PropType<CSS.Properties<string | 0>>;
    root: PropType<ShadowRoot | Document>;
    extensions: PropType<import("@codemirror/state").Extension | undefined>;
    selection: PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
    modelValue: {
        type: StringConstructor;
        required: false;
        default: string;
    };
}>> & {
    onUpdate?: ((viewUpdate: ViewUpdate) => any) | undefined;
    onChange?: ((value: string, viewUpdate: ViewUpdate) => any) | undefined;
    onFocus?: ((viewUpdate: ViewUpdate) => any) | undefined;
    onBlur?: ((viewUpdate: ViewUpdate) => any) | undefined;
    "onUpdate:modelValue"?: ((value: string, viewUpdate: ViewUpdate) => any) | undefined;
    onReady?: ((payload: {
        view: EditorView;
        state: EditorState;
        container: HTMLDivElement;
    }) => any) | undefined;
}, {
    autofocus: boolean;
    disabled: boolean;
    indentWithTab: boolean;
    modelValue: string;
}>;
declare const Codemirror: import("vue").DefineComponent<{
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: import("vue").PropType<import("csstype").Properties<string | 0>>;
    root: import("vue").PropType<ShadowRoot | Document>;
    extensions: import("vue").PropType<import("@codemirror/state").Extension | undefined>;
    selection: import("vue").PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
    modelValue: {
        type: StringConstructor;
        required: false;
        default: string;
    };
}, () => import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (value: string, viewUpdate: import("@codemirror/view").ViewUpdate) => true;
    change: (value: string, viewUpdate: import("@codemirror/view").ViewUpdate) => true;
    update: (viewUpdate: import("@codemirror/view").ViewUpdate) => true;
    focus: (viewUpdate: import("@codemirror/view").ViewUpdate) => true;
    blur: (viewUpdate: import("@codemirror/view").ViewUpdate) => true;
    ready: (payload: {
        view: import("@codemirror/view").EditorView;
        state: import("@codemirror/state").EditorState;
        container: HTMLDivElement;
    }) => true;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    autofocus: {
        type: BooleanConstructor;
        default: undefined;
    };
    disabled: {
        type: BooleanConstructor;
        default: undefined;
    };
    indentWithTab: {
        type: BooleanConstructor;
        default: undefined;
    };
    tabSize: NumberConstructor;
    placeholder: StringConstructor;
    style: import("vue").PropType<import("csstype").Properties<string | 0>>;
    root: import("vue").PropType<ShadowRoot | Document>;
    extensions: import("vue").PropType<import("@codemirror/state").Extension | undefined>;
    selection: import("vue").PropType<import("@codemirror/state").EditorSelection | {
        anchor: number;
        head?: number | undefined;
    } | undefined>;
    modelValue: {
        type: StringConstructor;
        required: false;
        default: string;
    };
}>> & {
    onUpdate?: ((viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    onChange?: ((value: string, viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    onFocus?: ((viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    onBlur?: ((viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    "onUpdate:modelValue"?: ((value: string, viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
    onReady?: ((payload: {
        view: import("@codemirror/view").EditorView;
        state: import("@codemirror/state").EditorState;
        container: HTMLDivElement;
    }) => any) | undefined;
}, {
    autofocus: boolean;
    disabled: boolean;
    indentWithTab: boolean;
    modelValue: string;
}>;
declare const install: Plugin;
declare const _default: {
    Codemirror: import("vue").DefineComponent<{
        autofocus: {
            type: BooleanConstructor;
            default: undefined;
        };
        disabled: {
            type: BooleanConstructor;
            default: undefined;
        };
        indentWithTab: {
            type: BooleanConstructor;
            default: undefined;
        };
        tabSize: NumberConstructor;
        placeholder: StringConstructor;
        style: import("vue").PropType<import("csstype").Properties<string | 0>>;
        root: import("vue").PropType<ShadowRoot | Document>;
        extensions: import("vue").PropType<import("@codemirror/state").Extension | undefined>;
        selection: import("vue").PropType<import("@codemirror/state").EditorSelection | {
            anchor: number;
            head?: number | undefined;
        } | undefined>;
        modelValue: {
            type: StringConstructor;
            required: false;
            default: string;
        };
    }, () => import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
        'update:modelValue': (value: string, viewUpdate: import("@codemirror/view").ViewUpdate) => true;
        change: (value: string, viewUpdate: import("@codemirror/view").ViewUpdate) => true;
        update: (viewUpdate: import("@codemirror/view").ViewUpdate) => true;
        focus: (viewUpdate: import("@codemirror/view").ViewUpdate) => true;
        blur: (viewUpdate: import("@codemirror/view").ViewUpdate) => true;
        ready: (payload: {
            view: import("@codemirror/view").EditorView;
            state: import("@codemirror/state").EditorState;
            container: HTMLDivElement;
        }) => true;
    }, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
        autofocus: {
            type: BooleanConstructor;
            default: undefined;
        };
        disabled: {
            type: BooleanConstructor;
            default: undefined;
        };
        indentWithTab: {
            type: BooleanConstructor;
            default: undefined;
        };
        tabSize: NumberConstructor;
        placeholder: StringConstructor;
        style: import("vue").PropType<import("csstype").Properties<string | 0>>;
        root: import("vue").PropType<ShadowRoot | Document>;
        extensions: import("vue").PropType<import("@codemirror/state").Extension | undefined>;
        selection: import("vue").PropType<import("@codemirror/state").EditorSelection | {
            anchor: number;
            head?: number | undefined;
        } | undefined>;
        modelValue: {
            type: StringConstructor;
            required: false;
            default: string;
        };
    }>> & {
        onUpdate?: ((viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        onChange?: ((value: string, viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        onFocus?: ((viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        onBlur?: ((viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        "onUpdate:modelValue"?: ((value: string, viewUpdate: import("@codemirror/view").ViewUpdate) => any) | undefined;
        onReady?: ((payload: {
            view: import("@codemirror/view").EditorView;
            state: import("@codemirror/state").EditorState;
            container: HTMLDivElement;
        }) => any) | undefined;
    }, {
        autofocus: boolean;
        disabled: boolean;
        indentWithTab: boolean;
        modelValue: string;
    }>;
    install: ((app: import("vue").App<any>, ...options: any[]) => any) & {
        install?: ((app: import("vue").App<any>, ...options: any[]) => any) | undefined;
    };
};
export type { Props };
export { _default as default, DEFAULT_CONFIG, Codemirror, install };
